local _, MaxiMap = ...
MaxiMap.Frames = {}
MaxiMap.Functions = {}
MaxiMap.Events = {}
function MaxiMap.Functions.CreateData()
local PlayerID = UnitGUID("player")
if (MaxiMapPerDB and MaxiMapPerDB.PlayerID) then
if (MaxiMapPerDB.PlayerID ~= PlayerID) then MaxiMapPerDB = nil; end
end
if (not MaxiMapPerDB) then MaxiMapPerDB = {}; end
if (not MaxiMapPerDB.PlayerID) then MaxiMapPerDB.PlayerID = PlayerID; end
MaxiMap.Data.IgnoreButtons = {"MiniMapWorldMapButton", "MiniMapTracking", "MinimapZoomIn", "MinimapZoomOut", "GarrisonLandingPageMinimapButton", "QueueStatusMinimapButton", "MiniMapMailFrame", "MinimapBackdrop", "GameTimeFrame", "TimeManagerClockButton", "MinimapZoneTextButton", "Minimap", "MiniMapInstanceDifficulty", "GuildInstanceDifficulty", "MiniMapChallengeMode"}
MaxiMap.Data.IgnorePins = {"HandyNotesPin", "GatherMatePin"}
MaxiMap.Data.ZoomMessage = {"Show Custom Size", "Show Maximum Size", "Show Minimum Size"}
if (not MaxiMapPerDB.MapSize) then
MaxiMapPerDB.MapZoom = 1
MaxiMapPerDB.MapSize = 140
MaxiMapPerDB.MapUnset = true
end
if (MaxiMapPerDB.ButtonsShown == nil) then MaxiMapPerDB.ButtonsShown = true; end
if (not MaxiMapPerDB.OptionValues) then MaxiMapPerDB.OptionValues = {true, true, true, true, true, true, true, true, true, true}; end
if (MaxiMapPerDB.OptionValues.CombatHide == nil) then MaxiMapPerDB.OptionValues.CombatHide = true; end
if (not MaxiMapPerDB.MapPositions) then MaxiMapPerDB.MapPositions = {{["GameTimeFrame"] = {}, ["GarrisonLandingPageMinimapButton"] = {}, ["MaxiMapZoom"] = {}, ["MiniMapMailFrame"] = {}, ["QueueStatusMinimapButton"] = {}, ["MiniMapTracking"] = {}, ["MaxiMapButton"] = {}}, {["GameTimeFrame"] = {}, ["GarrisonLandingPageMinimapButton"] = {}, ["MaxiMapZoom"] = {}, ["MiniMapMailFrame"] = {}, ["QueueStatusMinimapButton"] = {}, ["MiniMapTracking"] = {}, ["MaxiMapButton"] = {}}, {["GameTimeFrame"] = {}, ["GarrisonLandingPageMinimapButton"] = {}, ["MaxiMapZoom"] = {}, ["MiniMapMailFrame"] = {}, ["QueueStatusMinimapButton"] = {}, ["MiniMapTracking"] = {}, ["MaxiMapButton"] = {}}}; end
end
function GetMinimapShape() return "SQUARE" end
function MaxiMap.Functions.Tooltip(Self, msg)
GameTooltip:SetOwner(Self, "ANCHOR_BOTTOMRIGHT")
GameTooltip:SetText(msg or MaxiMap.Data.ZoomMessage[MaxiMapPerDB.MapZoom])
GameTooltip:Show()
end
function MaxiMap.Functions.Generic(Event, Blocked)
for i = 1, #Blocked do
for k, v in pairs(Blocked[i]) do
if (k == "UnregisterEvent") then
Blocked[i]:UnregisterAllEvents()
break
end
end
Blocked[i]:UnregisterEvent(Event)
end
end
function MaxiMap.Functions.ShowOptions() MaxiMap.Frames.Options:Refresh() end
function MaxiMap.Functions.CreateOptions()
local Title = MaxiMap.Frames.Options:CreateFontString("ARTWORK")
Title:SetFontObject("GameFontNormalLarge")
Title:SetPoint("TOPLEFT", 16, -16)
Title:SetText(MaxiMap.Data.Title.." v"..MaxiMap.Data.Version)
local Slash = MaxiMap.Frames.Options:CreateFontString("ARTWORK")
Slash:SetFontObject("GameFontNormal")
Slash:SetFont("Fonts\\FRIZQT__.TTF", 13)
Slash:SetPoint("TOPLEFT", Title, "BOTTOMLEFT", 0, -16)
Slash:SetText("|cffffffffType |cfff8f996"..SLASH_MAXIMAP1.."|cffffffff or |r"..SLASH_MAXIMAP2.."|cffffffff or |r"..SLASH_MAXIMAP3.."|cffffffff or |r"..SLASH_MAXIMAP4.."|cffffffff to open options")
local Directions1 = MaxiMap.Frames.Options:CreateFontString("ARTWORK")
Directions1:SetFontObject("GameFontNormal")
Directions1:SetFont("Fonts\\FRIZQT__.TTF", 13)
Directions1:SetPoint("TOPLEFT", Slash, "BOTTOMLEFT", 0, -32)
Directions1:SetText("|cffffffffUse |cfff8f996Scroll Wheel |cffffffffto zoom Minimap in or out")
local Directions2 = MaxiMap.Frames.Options:CreateFontString("ARTWORK")
Directions2:SetFontObject("GameFontNormal")
Directions2:SetFont("Fonts\\FRIZQT__.TTF", 13)
Directions2:SetPoint("TOPLEFT", Directions1, "BOTTOMLEFT", 0, -8)
Directions2:SetText("|cffffffffUse |cfff8f996Alt + Scroll Wheel |cffffffffto resize Minimap")
local Directions3 = MaxiMap.Frames.Options:CreateFontString("ARTWORK")
Directions3:SetFontObject("GameFontNormal")
Directions3:SetFont("Fonts\\FRIZQT__.TTF", 13)
Directions3:SetPoint("TOPLEFT", Directions2, "BOTTOMLEFT", 0, -8)
Directions3:SetText("|cffffffffHold down |cfff8f996Alt |cffffffffand drag Minimap Buttons to reposition them")
local ZoomButton = CreateFrame("Button", nil, MaxiMap.Frames.Options)
ZoomButton:SetSize(32, 32)
ZoomButton:SetPoint("TOPLEFT", 13, -164)
ZoomButton:SetNormalTexture("Interface\\MINIMAP\\UI-Minimap-ZoomInButton-Up")
local Directions4 = MaxiMap.Frames.Options:CreateFontString("ARTWORK")
Directions4:SetFontObject("GameFontNormal")
Directions4:SetFont("Fonts\\FRIZQT__.TTF", 13)
Directions4:SetPoint("LEFT", ZoomButton, "Right", 5, 0)
Directions4:SetText("|cffffffffSwitch between Minimum, Custom and Maximum Minimap size")
local ContainerButton = CreateFrame("Button", nil, MaxiMap.Frames.Options)
ContainerButton:SetSize(32, 32)
ContainerButton:SetPoint("TOPLEFT", ZoomButton, "BOTTOMLEFT", 0, 0)
local ContainerButtonIcon = ContainerButton:CreateTexture(nil, "OVERLAY")
ContainerButtonIcon:SetSize(32, 32)
ContainerButtonIcon:SetTexture("Interface\\MINIMAP\\MiniMap-VignetteArrow")
ContainerButtonIcon:SetRotation(1.5708)
ContainerButtonIcon:SetPoint("CENTER", -2, 2)
local Directions5 = MaxiMap.Frames.Options:CreateFontString("ARTWORK")
Directions5:SetFontObject("GameFontNormal")
Directions5:SetFont("Fonts\\FRIZQT__.TTF", 13)
Directions5:SetPoint("LEFT", ContainerButton, "Right", 5, 0)
Directions5:SetText("|cffffffffShow/Hide additional Minimap Buttons")
MaxiMap.Frames.CombatHide = CreateFrame("CheckButton", nil, MaxiMap.Frames.Options, "InterfaceOptionsCheckButtonTemplate")
MaxiMap.Frames.CombatHide.Text:SetFont("Fonts\\FRIZQT__.TTF", 13)
MaxiMap.Frames.CombatHide.Text:SetText("Hide additional Minimap Buttons when entering combat")
MaxiMap.Frames.CombatHide:SetHitRectInsets(0, -MaxiMap.Frames.CombatHide.Text:GetWidth(), 0, 0)
MaxiMap.Frames.CombatHide:SetPoint("TOPLEFT", ContainerButton, "BOTTOMLEFT", 0, -20)
MaxiMap.Frames.CombatHide:SetScript("OnClick", function(Self) end)
local OptionsBackground = CreateFrame("Frame", nil,  MaxiMap.Frames.Options, BackdropTemplateMixin and "BackdropTemplate")
OptionsBackground:SetBackdrop({bgFile = nil, edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = {left = 4, right = 4, top = 4, bottom = 4},})
OptionsBackground:SetHeight(254)
OptionsBackground:SetPoint("TOPLEFT", MaxiMapOptions, "TOPLEFT", 16, -296)
OptionsBackground:SetPoint("TOPRIGHT", MaxiMapOptions, "TOPRIGHT", -16, -296)
local OptionsTitle = OptionsBackground:CreateFontString("ARTWORK")
OptionsTitle:SetFontObject("GameFontNormalLarge")
OptionsTitle:SetPoint("TOP", 0, -8)
OptionsTitle:SetText("Enable Features")
MaxiMap.Frames.OptionButton = {}
local text = {"Zone Text", "Clock", "Calendar", "Challenge Mode", "Instance Difficulty", "Guild Instance Difficulty", "Mail", "Group Queue", "Tracking", "Garrison / Class Hall"}
local xPos = {10, 190, 390}
for i = 1, 10 do
MaxiMap.Frames.OptionButton[i] = CreateFrame("CheckButton", nil, OptionsBackground, "InterfaceOptionsCheckButtonTemplate")
MaxiMap.Frames.OptionButton[i].Text:SetFont("Fonts\\FRIZQT__.TTF", 13)
MaxiMap.Frames.OptionButton[i].Text:SetText(text[i])
MaxiMap.Frames.OptionButton[i]:SetHitRectInsets(0, -MaxiMap.Frames.OptionButton[i].Text:GetWidth(), 0, 0)
MaxiMap.Frames.OptionButton[i]:SetScript("OnClick", function(Self) end)
if (i <= 3) then MaxiMap.Frames.OptionButton[i]:SetPoint("TOPLEFT", xPos[i], -30); else MaxiMap.Frames.OptionButton[i]:SetPoint("TOPLEFT", MaxiMap.Frames.OptionButton[i - 3], "BOTTOMLEFT", 0, -8); end
end
function MaxiMap.Frames.Options:refresh()
if (not MaxiMap.Data.Default) then
MaxiMap.Frames.Reset:SetShown(false)
for i = 1, 10 do MaxiMap.Frames.OptionButton[i]:SetChecked(MaxiMapPerDB.OptionValues[i]) end
MaxiMap.Frames.CombatHide:SetChecked(MaxiMapPerDB.OptionValues.CombatHide)
end
MaxiMap.Data.Default = nil
end
function MaxiMap.Frames.Options:okay()
for i = 1, 10 do
MaxiMapPerDB.OptionValues[i] = MaxiMap.Frames.OptionButton[i]:GetChecked()
if (MaxiMapPerDB.OptionValues[i]) then CooldownFrame_Set(MaxiMap.Frames.EnableFrame[i], 1, 1, true); else CooldownFrame_Set(MaxiMap.Frames.EnableFrame[i + 10], 1, 1, true); end
end
MaxiMapPerDB.OptionValues.CombatHide = MaxiMap.Frames.CombatHide:GetChecked()
end
function MaxiMap.Frames.Options:default()
MaxiMap.Data.Default = true
MaxiMap.Frames.Reset:Show()
end
end
local function ValidButton(Frame)
if (Frame == MaxiMap.Frames.MiniSquareBackground or Frame == MaxiMap.Frames.ZoomButton or Frame == MaxiMap.Frames.ContainerButton or Frame == MaxiMap.Frames.ButtonContainer) then return false; end
for i = 1, 10 do if (Frame == MaxiMap.Frames.ParentFrame[i]) then return false; end end
for _, v in pairs(MaxiMap.Data.IgnoreButtons) do if (Frame:GetName() == v) then return false; end end
for _, v in pairs(MaxiMap.Data.IgnorePins) do if (tostring(Frame:GetName()):find(v)) then return false; end end
if (Frame.point and Frame.arrow) then return false; end
return true
end
local function FindButtons(Frame)
for _, v in pairs({Frame:GetChildren()}) do
if (not v:IsForbidden()) then
if (ValidButton(v)) then
local Parent = v:GetParent()
table.insert(MaxiMap.Data.ButtonList, {["Frame"] = v, ["Top"] = (Parent == MinimapBackdrop or Parent == Minimap or Parent == MinimapCluster), ["MiniMap"] = (v ~= MaxiMap.Frames.Minimap)})
if (v:GetNumChildren() > 0) then FindButtons(v); end
end
end
end
end
function MaxiMap.Functions.PositionButtons()
MaxiMap.Data.ButtonList = nil
MaxiMap.Data.ButtonList = {}
local Frames = {MinimapBackdrop, Minimap, MinimapCluster}
for _, v in pairs(Frames) do FindButtons(v) end
local Height, Width = 0, 0
for _, v in pairs(MaxiMap.Data.ButtonList) do
Height = math.max(Height, v.Frame:GetHeight())
Width = math.max(Width, v.Frame:GetWidth())
end
Width, Height = math.ceil(Width), math.ceil(Height)
MaxiMap.Frames.ButtonContainer:SetHeight(Height + 15)
local Left = 0
for _, v in pairs(MaxiMap.Data.ButtonList) do
if (v.Frame:HasScript("OnDragStart")) then v.Frame:SetScript("OnDragStart", nil); end
if (v.Frame:HasScript("OnDragStop")) then v.Frame:SetScript("OnDragStop", nil); end
if (v.Top) then
v.Frame:ClearAllPoints()
v.Frame:SetParent(MaxiMap.Frames.ButtonContainer)
v.Frame:SetPoint("LEFT", Left, 0)
if (v.Frame == _G["Rotacast.Frames.IconContainer"]) then
_G["Rotacast.Frames.Icon"]:ClearAllPoints()
_G["Rotacast.Frames.Icon"]:SetPoint("BOTTOMRIGHT")
end
if (v.MiniMap) then Left = Left + Width + 3; end
end
end
MaxiMap.Frames.ButtonContainer:SetWidth(Left - 3)
end
function MaxiMap.Functions.InitData()
MaxiMap.Functions.CreateData()
MaxiMap.Functions.CreateFrames()
MaxiMap.Functions.CreateEvents()
MaxiMap.Functions.CreateReferences()
MaxiMap.Functions.CreateOptions()
MaxiMap.Frames.Options.name = MaxiMap.Data.Title
InterfaceOptions_AddCategory(MaxiMap.Frames.Options)
MaxiMap.Frames.Options:Hide()
C_Timer.After(0, function()
local bottomLimit = MicroButtonAndBagsBar:GetTop() + 24
MaxiMap.Frames.MultiFrame:SetAttribute("multioffset", ((((VERTICAL_MULTI_BAR_HEIGHT + VERTICAL_MULTI_BAR_VERTICAL_SPACING) - VERTICAL_MULTI_BAR_HEIGHT) / 2) - ((GetScreenHeight() / 2) - ((((MinimapCluster:GetBottom() - 10) - bottomLimit) / 2) + bottomLimit))) - 10)
local Size
if (MaxiMapPerDB.MapZoom == 1) then Size = 140; elseif (MaxiMapPerDB.MapZoom == 2) then Size = MaxiMapPerDB.MapSize; else Size = 880; end
MinimapCluster:SetSize(Size + 52, Size + 52)
Minimap:SetSize(Size, Size)
MinimapBackdrop:SetSize(Size + 52, Size + 52)
MaxiMap.Frames.MiniSquareBackground:SetSize(Size + 10, Size + 10)
local ZoomCurrent = Minimap:GetZoom()
local ZoomLevel = ZoomCurrent + 1
if (ZoomLevel >= Minimap:GetZoomLevels()) then ZoomLevel = 0; end
Minimap:SetZoom(ZoomLevel)
Minimap:SetZoom(ZoomCurrent)
MaxiMap.Functions.PositionButtons()
local Top = VerticalMultiBarsContainer:GetTop()
local Left = 0
if (Top) then
local Bottom = MinimapBackdrop:GetBottom() + 10
if (Bottom  <= Top) then Left = VerticalMultiBarsContainer:GetWidth(); end
end
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MaxiMapButton[1]) then MaxiMap.Frames.ContainerButton:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MaxiMapButton[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MaxiMapButton[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MaxiMapButton[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MaxiMapButton[5]); else MaxiMap.Frames.ContainerButton:SetPoint("BOTTOMRIGHT", MaxiMap.Frames.MiniSquareBackground, "BOTTOMRIGHT", 25 - Left, -19); end
MaxiMap.Functions.Generic("ADDON_ACTION_BLOCKED", {GetFramesRegisteredForEvent("ADDON_ACTION_BLOCKED")})
MaxiMap.Functions.Generic("ADDON_ACTION_FORBIDDEN", {GetFramesRegisteredForEvent("ADDON_ACTION_FORBIDDEN")})
end)
hooksecurefunc("MultiActionBar_Update", function(Self)
if ((MultiBarLeft:IsShown() or MultiBarRight:IsShown()) and MaxiMap.Frames.MultiFrame:GetAttribute("multioffset")) then CooldownFrame_Set(MaxiMap.Frames.MultiFrame, 1, 1, true); end
if (MaxiMap.Frames.Reposition and MaxiMap.Frames.ButtonContainer:GetBottom()) then CooldownFrame_Set(MaxiMap.Frames.Reposition, 1, 1, true); end
C_Timer.After(0, function()
local Offset = -12
if (MultiBarLeft:IsShown()) then Offset = Offset - VERTICAL_MULTI_BAR_WIDTH; end
if (MultiBarRight:IsShown()) then Offset = Offset - VERTICAL_MULTI_BAR_WIDTH; end
if (MultiBarLeft:IsShown() and MultiBarRight:IsShown()) then Offset = Offset - VERTICAL_MULTI_BAR_HORIZONTAL_SPACING; end
if (IsAddOnLoaded("!KalielsTracker")) then
local Point = select(4, _G["!KalielsTrackerFrame"]:GetPoint())
_G["!KalielsTrackerFrame"]:AdjustPointsOffset(Offset - Point, 0)
else
local Point = select(4, ObjectiveTrackerFrame:GetPoint())
ObjectiveTrackerFrame:AdjustPointsOffset(Offset - Point, 0)
end
end)
end)
if (MaxiMapPerDB.MapPositions[1].GameTimeFrame[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("GameTimeFrameX1", MaxiMapPerDB.MapPositions[1].GameTimeFrame[4])
MaxiMap.Frames.ZoomButton:SetAttribute("GameTimeFrameY1", MaxiMapPerDB.MapPositions[1].GameTimeFrame[5])
end
if (MaxiMapPerDB.MapPositions[2].GameTimeFrame[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("GameTimeFrameX2", MaxiMapPerDB.MapPositions[2].GameTimeFrame[4])
MaxiMap.Frames.ZoomButton:SetAttribute("GameTimeFrameY2", MaxiMapPerDB.MapPositions[2].GameTimeFrame[5])
end
if (MaxiMapPerDB.MapPositions[3].GameTimeFrame[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("GameTimeFrameX3", MaxiMapPerDB.MapPositions[3].GameTimeFrame[4])
MaxiMap.Frames.ZoomButton:SetAttribute("GameTimeFrameY3", MaxiMapPerDB.MapPositions[3].GameTimeFrame[5])
end
if (MaxiMapPerDB.MapPositions[1].GarrisonLandingPageMinimapButton[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("GarrisonLandingPageMinimapButtonX1", MaxiMapPerDB.MapPositions[1].GarrisonLandingPageMinimapButton[4])
MaxiMap.Frames.ZoomButton:SetAttribute("GarrisonLandingPageMinimapButtonY1", MaxiMapPerDB.MapPositions[1].GarrisonLandingPageMinimapButton[5])
end
if (MaxiMapPerDB.MapPositions[2].GarrisonLandingPageMinimapButton[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("GarrisonLandingPageMinimapButtonX2", MaxiMapPerDB.MapPositions[2].GarrisonLandingPageMinimapButton[4])
MaxiMap.Frames.ZoomButton:SetAttribute("GarrisonLandingPageMinimapButtonY2", MaxiMapPerDB.MapPositions[2].GarrisonLandingPageMinimapButton[5])
end
if (MaxiMapPerDB.MapPositions[3].GarrisonLandingPageMinimapButton[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("GarrisonLandingPageMinimapButtonX3", MaxiMapPerDB.MapPositions[3].GarrisonLandingPageMinimapButton[4])
MaxiMap.Frames.ZoomButton:SetAttribute("GarrisonLandingPageMinimapButtonY3", MaxiMapPerDB.MapPositions[3].GarrisonLandingPageMinimapButton[5])
end
if (MaxiMapPerDB.MapPositions[1].MaxiMapZoom[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapZoomX1", MaxiMapPerDB.MapPositions[1].MaxiMapZoom[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapZoomY1", MaxiMapPerDB.MapPositions[1].MaxiMapZoom[5])
end
if (MaxiMapPerDB.MapPositions[2].MaxiMapZoom[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapZoomX2", MaxiMapPerDB.MapPositions[2].MaxiMapZoom[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapZoomY2", MaxiMapPerDB.MapPositions[2].MaxiMapZoom[5])
end
if (MaxiMapPerDB.MapPositions[3].MaxiMapZoom[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapZoomX3", MaxiMapPerDB.MapPositions[3].MaxiMapZoom[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapZoomY3", MaxiMapPerDB.MapPositions[3].MaxiMapZoom[5])
end
if (MaxiMapPerDB.MapPositions[1].MiniMapMailFrame[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapMailFrameX1", MaxiMapPerDB.MapPositions[1].MiniMapMailFrame[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapMailFrameY1", MaxiMapPerDB.MapPositions[1].MiniMapMailFrame[5])
end
if (MaxiMapPerDB.MapPositions[2].MiniMapMailFrame[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapMailFrameX2", MaxiMapPerDB.MapPositions[2].MiniMapMailFrame[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapMailFrameY2", MaxiMapPerDB.MapPositions[2].MiniMapMailFrame[5])
end
if (MaxiMapPerDB.MapPositions[3].MiniMapMailFrame[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapMailFrameX3", MaxiMapPerDB.MapPositions[3].MiniMapMailFrame[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapMailFrameY3", MaxiMapPerDB.MapPositions[3].MiniMapMailFrame[5])
end
if (MaxiMapPerDB.MapPositions[1].QueueStatusMinimapButton[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("QueueStatusMinimapButtonX1", MaxiMapPerDB.MapPositions[1].QueueStatusMinimapButton[4])
MaxiMap.Frames.ZoomButton:SetAttribute("QueueStatusMinimapButtonY1", MaxiMapPerDB.MapPositions[1].QueueStatusMinimapButton[5])
end
if (MaxiMapPerDB.MapPositions[2].QueueStatusMinimapButton[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("QueueStatusMinimapButtonX2", MaxiMapPerDB.MapPositions[2].QueueStatusMinimapButton[4])
MaxiMap.Frames.ZoomButton:SetAttribute("QueueStatusMinimapButtonY2", MaxiMapPerDB.MapPositions[2].QueueStatusMinimapButton[5])
end
if (MaxiMapPerDB.MapPositions[3].QueueStatusMinimapButton[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("QueueStatusMinimapButtonX3", MaxiMapPerDB.MapPositions[3].QueueStatusMinimapButton[4])
MaxiMap.Frames.ZoomButton:SetAttribute("QueueStatusMinimapButtonY3", MaxiMapPerDB.MapPositions[3].QueueStatusMinimapButton[5])
end
if (MaxiMapPerDB.MapPositions[1].MiniMapTracking[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapTrackingX1", MaxiMapPerDB.MapPositions[1].MiniMapTracking[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapTrackingY1", MaxiMapPerDB.MapPositions[1].MiniMapTracking[5])
end
if (MaxiMapPerDB.MapPositions[2].MiniMapTracking[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapTrackingX2", MaxiMapPerDB.MapPositions[2].MiniMapTracking[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapTrackingY2", MaxiMapPerDB.MapPositions[2].MiniMapTracking[5])
end
if (MaxiMapPerDB.MapPositions[3].MiniMapTracking[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapTrackingX3", MaxiMapPerDB.MapPositions[3].MiniMapTracking[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MiniMapTrackingY3", MaxiMapPerDB.MapPositions[3].MiniMapTracking[5])
end
if (MaxiMapPerDB.MapPositions[1].MaxiMapButton[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapButtonX1", MaxiMapPerDB.MapPositions[1].MaxiMapButton[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapButtonY1", MaxiMapPerDB.MapPositions[1].MaxiMapButton[5])
end
if (MaxiMapPerDB.MapPositions[2].MaxiMapButton[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapButtonX2", MaxiMapPerDB.MapPositions[2].MaxiMapButton[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapButtonY2", MaxiMapPerDB.MapPositions[2].MaxiMapButton[5])
end
if (MaxiMapPerDB.MapPositions[3].MaxiMapButton[1]) then
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapButtonX3", MaxiMapPerDB.MapPositions[3].MaxiMapButton[4])
MaxiMap.Frames.ZoomButton:SetAttribute("MaxiMapButtonY3", MaxiMapPerDB.MapPositions[3].MaxiMapButton[5])
end
MaxiMap.Frames.Event:RegisterEvent("PLAYER_REGEN_DISABLED")
MaxiMap.Frames.Event:RegisterEvent("PLAYER_REGEN_ENABLED")
print(" ")
print("|cffffe00a".."(".."|cffff7d0a"..MaxiMap.Data.Title, "v"..MaxiMap.Data.Version, "|cff69ccf0".."Loaded".."|cffffe00a"..")")
print("|cfff8f996"..SLASH_MAXIMAP1..", "..SLASH_MAXIMAP2..", "..SLASH_MAXIMAP3..", "..SLASH_MAXIMAP4)
print(" ")
end
function MaxiMap.Functions.OnDragStart(Self)
if (not InCombatLockdown() and IsAltKeyDown()) then
Self.MaxiMapUpdated = true
Self:SetScript("OnUpdate", MaxiMap.Functions.OnUpdate)
end
end
function MaxiMap.Functions.OnDragStop(Self)
Self:SetScript("OnUpdate", nil)
if (not InCombatLockdown() and Self.MaxiMapUpdated) then
Self.MaxiMapUpdated = nil
MaxiMap.Functions.SavePosition(Self)
end
end
function MaxiMap.Functions.SavePosition(Self)
if (Self) then
local points = {Self:GetPoint()}
MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom][tostring(Self:GetName())] = points
MaxiMap.Frames.ZoomButton:SetAttribute(tostring(Self:GetName()).."X"..MaxiMapPerDB.MapZoom, points[4])
MaxiMap.Frames.ZoomButton:SetAttribute(tostring(Self:GetName()).."Y"..MaxiMapPerDB.MapZoom, points[5])
else
if (MaxiMap.Frames.ZoomButton:GetAttribute("GameTimeFrameX2")) then MaxiMapPerDB.MapPositions[2].GameTimeFrame = {GameTimeFrame:GetPoint()}; end
if (MaxiMap.Frames.ZoomButton:GetAttribute("GarrisonLandingPageMinimapButtonX2")) then MaxiMapPerDB.MapPositions[2].GarrisonLandingPageMinimapButton = {GarrisonLandingPageMinimapButton:GetPoint()}; end
if (MaxiMap.Frames.ZoomButton:GetAttribute("MaxiMapZoomX2")) then MaxiMapPerDB.MapPositions[2].MaxiMapZoom = {MaxiMap.Frames.ZoomButton:GetPoint()}; end
if (MaxiMap.Frames.ZoomButton:GetAttribute("MiniMapMailFrameX2")) then MaxiMapPerDB.MapPositions[2].MiniMapMailFrame = {MiniMapMailFrame:GetPoint()}; end
if (MaxiMap.Frames.ZoomButton:GetAttribute("QueueStatusMinimapButtonX2")) then MaxiMapPerDB.MapPositions[2].QueueStatusMinimapButton = {QueueStatusMinimapButton:GetPoint()}; end
if (MaxiMap.Frames.ZoomButton:GetAttribute("MiniMapTrackingX2")) then MaxiMapPerDB.MapPositions[2].MiniMapTracking = {MiniMapTracking:GetPoint()}; end
if (MaxiMap.Frames.ZoomButton:GetAttribute("MaxiMapButtonX2")) then MaxiMapPerDB.MapPositions[2].MaxiMapButton = {MaxiMap.Frames.ContainerButton:GetPoint()}; end
end
end
function MaxiMap.Functions.OnUpdate(Self)
local MapX, MapY = Minimap:GetCenter()
local CurX, CurY = GetCursorPosition()
local Scale = Minimap:GetEffectiveScale()
CurX, CurY = CurX / Scale, CurY / Scale
local Pos = math.deg(math.atan2(CurY - MapY, CurX - MapX)) % 360
MaxiMap.Functions.UpdatePosition(Self, Pos)
end
function MaxiMap.Functions.UpdatePosition(Self, Pos)
local Angle = math.rad(Pos or 225)
local xOff, yOff = math.cos(Angle), math.sin(Angle)
local Width = (MaxiMap.Frames.MiniSquareBackground:GetWidth() / 2) + 22.25 + ((MaxiMap.Frames.MiniSquareBackground:GetWidth() - 150) / 9)
local Height = (MaxiMap.Frames.MiniSquareBackground:GetHeight() / 2) + 22.25 + ((MaxiMap.Frames.MiniSquareBackground:GetWidth() - 150) / 9)
local WidthR = math.sqrt(2 * (Width) ^ 2) - 10
local HeightR = math.sqrt(2 * (Height) ^ 2) - 10
xOff = math.max(-Width, math.min(xOff * WidthR, Width))
yOff = math.max(-Height, math.min(yOff * HeightR, Height))
Self:ClearAllPoints()
Self:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "CENTER", xOff, yOff)
if (Self ~= GameTimeFrame and Self ~= GarrisonLandingPageMinimapButton) then
local DifX, DifY = 0, 0
if (Self:GetLeft() < MaxiMap.Frames.MiniSquareBackground:GetLeft()) then DifX =  (MaxiMap.Frames.MiniSquareBackground:GetLeft() - Self:GetLeft()) - (Self:GetWidth() / 2); elseif (Self:GetRight() > MaxiMap.Frames.MiniSquareBackground:GetRight()) then DifX = (MaxiMap.Frames.MiniSquareBackground:GetRight() - Self:GetRight()) + (Self:GetWidth() / 2); end
if (Self:GetTop() > MaxiMap.Frames.MiniSquareBackground:GetTop()) then DifY = (MaxiMap.Frames.MiniSquareBackground:GetTop() - Self:GetTop()) + (Self:GetHeight() / 2); elseif (MaxiMap.Frames.MiniSquareBackground:GetBottom() > Self:GetBottom()) then DifY = (MaxiMap.Frames.MiniSquareBackground:GetBottom() - Self:GetBottom()) - (Self:GetHeight() / 2); end
Self:AdjustPointsOffset(DifX, DifY)
end
end
function MaxiMap.Functions.MoveAnything(Self)
if (not MAOptions:IsShown()) then Self:SetScript("OnUpdate", nil); end
for i = 1, MADB.frameListRows, 1 do
local Row = _G["MAMove"..i]
for _, v in pairs(MaxiMap.Data.MoveAnything) do 	if (Row.idx == v) then Row:Hide(); end end
end
end
function MaxiMap.Functions.CreateFrames()
MaxiMap.Frames.Reset = CreateFrame("Frame", nil, InterfaceOptionsFrame, BackdropTemplateMixin and "BackdropTemplate")
MaxiMap.Frames.Reset:SetSize(300, 140)
MaxiMap.Frames.Reset:SetFrameStrata("DIALOG")
MaxiMap.Frames.Reset:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UI-Background-Marble", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = false,	 insets = {left = 10, right = 10, top = 10, bottom = 10}, tileSize = 32, edgeSize = 32}
MaxiMap.Frames.Reset:SetPoint("TOP")
MaxiMap.Frames.Reset.Header = CreateFrame("Frame", nil, MaxiMap.Frames.Reset, BackdropTemplateMixin and "BackdropTemplate")
MaxiMap.Frames.Reset.Header:SetSize(120, 42)
MaxiMap.Frames.Reset.Header:SetPoint("TOP", 0, 15)
MaxiMap.Frames.Reset.Header:SetBackdrop{bgFile = "Interface\\FrameGeneral\\UIFrameNightFaeBackground", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = false,	 insets = {left = 10, right = 10, top = 10, bottom = 10}, tileSize = 32, edgeSize = 32}
MaxiMap.Frames.Reset.Title = MaxiMap.Frames.Reset.Header:CreateFontString("ARTWORK")
MaxiMap.Frames.Reset.Title:SetFontObject("GameFontNormalLarge")
MaxiMap.Frames.Reset.Title:SetPoint("CENTER")
MaxiMap.Frames.Reset.Title:SetText(MaxiMap.Data.Title)
MaxiMap.Frames.Reset.Message1 = MaxiMap.Frames.Reset:CreateFontString("ARTWORK")
MaxiMap.Frames.Reset.Message1:SetFontObject("GameFontNormal")
MaxiMap.Frames.Reset.Message1:SetFont("Fonts\\FRIZQT__.TTF", 15)
MaxiMap.Frames.Reset.Message1:SetPoint("TOP", 0, -40)
MaxiMap.Frames.Reset.Message1:SetText("|cffffffffResetting will reload your UI")
MaxiMap.Frames.Reset.Message2 = MaxiMap.Frames.Reset:CreateFontString("ARTWORK")
MaxiMap.Frames.Reset.Message2:SetFontObject("GameFontNormal")
MaxiMap.Frames.Reset.Message2:SetFont("Fonts\\FRIZQT__.TTF", 13)
MaxiMap.Frames.Reset.Message2:SetPoint("TOP", MaxiMap.Frames.Reset.Message1, "BOTTOM", 0, -10)
MaxiMap.Frames.Reset.Message2:SetText("|cffffffffdo you want to continue?")
MaxiMap.Frames.Reset.Yes = CreateFrame("Button", nil, MaxiMap.Frames.Reset, "UIPanelButtonTemplate")
MaxiMap.Frames.Reset.Yes:SetSize(100, 30)
MaxiMap.Frames.Reset.Yes:SetPoint("BOTTOMLEFT", 20, 20)
MaxiMap.Frames.Reset.Yes:SetText("Absolutely!")
MaxiMap.Frames.Reset.No = CreateFrame("Button", nil, MaxiMap.Frames.Reset, "UIPanelButtonTemplate")
MaxiMap.Frames.Reset.No:SetSize(100, 30)
MaxiMap.Frames.Reset.No:SetPoint("BOTTOMRIGHT", -20, 20)
MaxiMap.Frames.Reset.No:SetText("Not Really")
MaxiMap.Frames.Reset:SetShown(false)
MaxiMap.Frames.Minimap = CreateFrame("Button", nil, MinimapBackdrop, "SecureHandlerClickTemplate")
MiniMapWorldMapButton:Hide()
MinimapBorderTop:Hide()
MinimapNorthTag:SetTexture()
MinimapBorder:Hide()
Minimap:EnableMouseWheel(true)
MinimapZoomIn:Hide()
MinimapZoomOut:Hide()
Minimap:SetMaskTexture("Interface\\BUTTONS\\WHITE8X8")
Minimap:SetArchBlobRingScalar(0)
Minimap:SetQuestBlobRingScalar(0)
Minimap:ClearAllPoints()
Minimap:SetPoint("CENTER", MinimapCluster, "CENTER", 0, -5)
MinimapBackdrop:ClearAllPoints()
MinimapBackdrop:SetPoint("CENTER", MinimapCluster, "CENTER", 0, -5)
MinimapZoneTextButton:ClearAllPoints()
MinimapZoneTextButton:SetPoint("TOP", 0, -5)
TimeManagerClockButton:GetRegions():Hide()
TimeManagerClockButton:ClearAllPoints()
TimeManagerClockButton:SetPoint("CENTER", Minimap, "TOP", 0, 0)
MaxiMap.Frames.MiniSquareBackground = CreateFrame("Frame", "MiniSquareBackground", Minimap, BackdropTemplateMixin and "BackdropTemplate, SecureHandlerMouseWheelTemplate")
MaxiMap.Frames.MiniSquareBackground:SetFrameStrata("BACKGROUND")
MaxiMap.Frames.MiniSquareBackground:SetBackdrop({bgFile = nil, edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = {left = 4, right = 4, top = 4, bottom = 4},})
MaxiMap.Frames.MiniSquareBackground:SetPoint("CENTER")
MaxiMap.Frames.ZoomButton = CreateFrame("Button", "MaxiMapZoom", MaxiMap.Frames.MiniSquareBackground, "SecureHandlerClickTemplate")
MaxiMap.Frames.ZoomButton:SetFrameStrata("HIGH")
MaxiMap.Frames.ZoomButton:SetSize(32, 32)
MaxiMap.Frames.ZoomButton:SetMovable(true)
MaxiMap.Frames.ZoomButton:RegisterForDrag("LeftButton")
MaxiMap.Frames.ZoomButton:SetScript("OnDragStart", MaxiMap.Functions.OnDragStart)
MaxiMap.Frames.ZoomButton:SetScript("OnDragStop", MaxiMap.Functions.OnDragStop)
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MaxiMapZoom[1]) then MaxiMap.Frames.ZoomButton:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MaxiMapZoom[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MaxiMapZoom[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MaxiMapZoom[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MaxiMapZoom[5]); else MaxiMap.Frames.ZoomButton:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "TOPRIGHT", 0, -5); end
if (MaxiMapPerDB.MapZoom == 3) then
MaxiMap.Frames.ZoomButton:SetNormalTexture("Interface\\MINIMAP\\UI-Minimap-ZoomOutButton-Up")
MaxiMap.Frames.ZoomButton:SetPushedTexture("Interface\\MINIMAP\\UI-Minimap-ZoomOutButton-Down")
else
MaxiMap.Frames.ZoomButton:SetNormalTexture("Interface\\MINIMAP\\UI-Minimap-ZoomInButton-Up")
MaxiMap.Frames.ZoomButton:SetPushedTexture("Interface\\MINIMAP\\UI-Minimap-ZoomInButton-Down")
end
MaxiMap.Frames.ZoomButton:SetHighlightTexture("Interface\\MINIMAP\\UI-Minimap-ZoomButton-Highlight")
MaxiMap.Frames.ContainerButton = CreateFrame("Button", "MaxiMapButton", MaxiMap.Frames.MiniSquareBackground, "SecureHandlerClickTemplate")
MaxiMap.Frames.ContainerButton:SetFrameStrata("HIGH")
MaxiMap.Frames.ContainerButton:SetSize(40, 40)
MaxiMap.Frames.ContainerButton:SetMovable(true)
MaxiMap.Frames.ContainerButton:RegisterForDrag("LeftButton")
MaxiMap.Frames.ContainerButton:SetScript("OnDragStart", MaxiMap.Functions.OnDragStart)
MaxiMap.Frames.ContainerButton:SetScript("OnDragStop", MaxiMap.Functions.OnDragStop)
MaxiMap.Frames.ContainerButton:SetHighlightTexture("Interface\\COMMON\\CommonRoundHighlight")
local Icon = MaxiMap.Frames.ContainerButton:CreateTexture(nil, "OVERLAY")
Icon:SetSize(40, 40)
Icon:SetTexture("Interface\\MINIMAP\\MiniMap-VignetteArrow")
Icon:SetRotation(1.5708)
Icon:SetPoint("CENTER", -2, 2)
MaxiMap.Frames.ButtonContainer = CreateFrame("Frame", nil, MaxiMap.Frames.MiniSquareBackground, BackdropTemplateMixin and "BackdropTemplate")
MaxiMap.Frames.ButtonContainer:SetFrameStrata("TOOLTIP")
MaxiMap.Frames.ButtonContainer:SetPoint("RIGHT", MaxiMap.Frames.ContainerButton, "LEFT", 0, 2)
MaxiMap.Frames.ButtonContainer:SetShown(MaxiMapPerDB.ButtonsShown)
MaxiMap.Frames.ParentFrame = {}
MaxiMap.Frames.ParentFrame[1] = CreateFrame("Frame", nil, MinimapCluster, "SecureHandlerBaseTemplate")
MaxiMap.Frames.ParentFrame[1]:SetAllPoints(MinimapZoneTextButton)
MinimapZoneTextButton:SetParent(MaxiMap.Frames.ParentFrame[1])
MaxiMap.Frames.ParentFrame[2] = CreateFrame("Frame", nil, Minimap, BackdropTemplateMixin and "BackdropTemplate, SecureHandlerBaseTemplate")
MaxiMap.Frames.ParentFrame[2]:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background-Azerite", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = {left = 4, right = 4, top = 4, bottom = 4},})
MaxiMap.Frames.ParentFrame[2]:SetSize(50, 25)
MaxiMap.Frames.ParentFrame[2]:SetPoint("CENTER", Minimap, "TOP", 0, 0)
TimeManagerClockButton:SetParent(MaxiMap.Frames.ParentFrame[2])
TimeManagerClockButton:SetPoint("CENTER", MaxiMap.Frames.ParentFrame[2], "CENTER", -2, -1)
GameTimeFrame:ClearAllPoints()
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GameTimeFrame[1]) then GameTimeFrame:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GameTimeFrame[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GameTimeFrame[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GameTimeFrame[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GameTimeFrame[5]); else GameTimeFrame:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "TOPLEFT", -5, -14); end
GameTimeFrame:SetSize(46, 46)
GameTimeFrame:SetScale(.81)
GameTimeFrame:SetMovable(true)
GameTimeFrame:RegisterForDrag("LeftButton")
GameTimeFrame:SetScript("OnDragStart", MaxiMap.Functions.OnDragStart)
GameTimeFrame:SetScript("OnDragStop", MaxiMap.Functions.OnDragStop)
MaxiMap.Frames.ParentFrame[3] = CreateFrame("Frame", nil, MaxiMap.Frames.MiniSquareBackground, "SecureHandlerBaseTemplate")
MaxiMap.Frames.ParentFrame[3]:SetFrameStrata("HIGH")
MaxiMap.Frames.ParentFrame[3]:SetAllPoints(GameTimeFrame)
GameTimeFrame:SetParent(MaxiMap.Frames.ParentFrame[3])
MiniMapChallengeMode:ClearAllPoints()
MiniMapChallengeMode:SetPoint("TOPRIGHT", MinimapCluster, "TOPRIGHT", -38, -24)
MaxiMap.Frames.ParentFrame[4] = CreateFrame("Frame", nil, Minimap, "SecureHandlerBaseTemplate")
MaxiMap.Frames.ParentFrame[4]:SetAllPoints(MiniMapChallengeMode)
MiniMapChallengeMode:SetParent(MaxiMap.Frames.ParentFrame[4])
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint("TOPRIGHT", MinimapCluster, "TOPRIGHT", -32, -19)
MaxiMap.Frames.ParentFrame[5] = CreateFrame("Frame", nil, Minimap, "SecureHandlerBaseTemplate")
MaxiMap.Frames.ParentFrame[5]:SetAllPoints(MiniMapInstanceDifficulty)
MiniMapInstanceDifficulty:SetParent(MaxiMap.Frames.ParentFrame[5])
GuildInstanceDifficulty:ClearAllPoints()
GuildInstanceDifficulty:SetPoint("TOPRIGHT", MinimapCluster, "TOPRIGHT", -34, -18)
MaxiMap.Frames.ParentFrame[6] = CreateFrame("Frame", nil, Minimap, "SecureHandlerBaseTemplate")
MaxiMap.Frames.ParentFrame[6]:SetAllPoints(GuildInstanceDifficulty)
GuildInstanceDifficulty:SetParent(MaxiMap.Frames.ParentFrame[6])
MiniMapMailFrame:ClearAllPoints()
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapMailFrame[1]) then MiniMapMailFrame:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapMailFrame[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapMailFrame[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapMailFrame[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapMailFrame[5]); else MiniMapMailFrame:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "TOPRIGHT", 0, -40); end
MiniMapMailFrame:SetMovable(true)
MiniMapMailFrame:RegisterForDrag("LeftButton")
MiniMapMailFrame:SetScript("OnDragStart", MaxiMap.Functions.OnDragStart)
MiniMapMailFrame:SetScript("OnDragStop", MaxiMap.Functions.OnDragStop)
MaxiMap.Frames.ParentFrame[7] = CreateFrame("Frame", nil, MaxiMap.Frames.MiniSquareBackground, "SecureHandlerBaseTemplate")
MaxiMap.Frames.ParentFrame[7]:SetFrameStrata("HIGH")
MaxiMap.Frames.ParentFrame[7]:SetAllPoints(MiniMapMailFrame)
MiniMapMailFrame:SetParent(MaxiMap.Frames.ParentFrame[7])
QueueStatusMinimapButton:ClearAllPoints()
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].QueueStatusMinimapButton[1]) then QueueStatusMinimapButton:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].QueueStatusMinimapButton[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].QueueStatusMinimapButton[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].QueueStatusMinimapButton[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].QueueStatusMinimapButton[5]); else QueueStatusMinimapButton:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "TOPRIGHT", 0, -75); end
QueueStatusMinimapButton:SetMovable(true)
QueueStatusMinimapButton:RegisterForDrag("LeftButton")
QueueStatusMinimapButton:SetScript("OnDragStart", MaxiMap.Functions.OnDragStart)
QueueStatusMinimapButton:SetScript("OnDragStop", MaxiMap.Functions.OnDragStop)
MaxiMap.Frames.ParentFrame[8] = CreateFrame("Frame", nil, MaxiMap.Frames.MiniSquareBackground, "SecureHandlerBaseTemplate")
MaxiMap.Frames.ParentFrame[8]:SetFrameStrata("HIGH")
MaxiMap.Frames.ParentFrame[8]:SetAllPoints(QueueStatusMinimapButton)
QueueStatusMinimapButton:SetParent(MaxiMap.Frames.ParentFrame[8])
MiniMapTracking:ClearAllPoints()
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapTracking[1]) then MiniMapTracking:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapTracking[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapTracking[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapTracking[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapTracking[5]); else MiniMapTracking:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "TOPRIGHT", 0, -110); end
MiniMapTrackingButton:SetScript("OnMouseDown", function(Self) if (IsAltKeyDown()) then MaxiMap.Functions.OnDragStart(MiniMapTracking); else ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, "MiniMapTracking", -80, 5); end end)
MiniMapTrackingButton:SetScript("OnMouseUp", function(Self) MaxiMap.Functions.OnDragStop(MiniMapTracking) end)
MaxiMap.Frames.ParentFrame[9] = CreateFrame("Frame", nil, MaxiMap.Frames.MiniSquareBackground, "SecureHandlerBaseTemplate")
MaxiMap.Frames.ParentFrame[9]:SetFrameStrata("HIGH")
MaxiMap.Frames.ParentFrame[9]:SetAllPoints(MiniMapTracking)
MiniMapTracking:SetParent(MaxiMap.Frames.ParentFrame[9])
hooksecurefunc("GarrisonLandingPageMinimapButton_UpdateIcon", function(Self)
Self:ClearAllPoints()
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GarrisonLandingPageMinimapButton[1]) then Self:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GarrisonLandingPageMinimapButton[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GarrisonLandingPageMinimapButton[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GarrisonLandingPageMinimapButton[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GarrisonLandingPageMinimapButton[5]); else Self:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "TOPLEFT", -5, -74); end
end)
GarrisonLandingPageMinimapButton:ClearAllPoints()
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GarrisonLandingPageMinimapButton[1]) then GarrisonLandingPageMinimapButton:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GarrisonLandingPageMinimapButton[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GarrisonLandingPageMinimapButton[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GarrisonLandingPageMinimapButton[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GarrisonLandingPageMinimapButton[5]); else GarrisonLandingPageMinimapButton:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "TOPLEFT", -5, -74); end
GarrisonLandingPageMinimapButton:SetScale(.81)
GarrisonLandingPageMinimapButton:SetMovable(true)
GarrisonLandingPageMinimapButton:RegisterForDrag("LeftButton")
GarrisonLandingPageMinimapButton:SetScript("OnDragStart", MaxiMap.Functions.OnDragStart)
GarrisonLandingPageMinimapButton:SetScript("OnDragStop", MaxiMap.Functions.OnDragStop)
MaxiMap.Frames.ParentFrame[10] = CreateFrame("Frame", nil, MaxiMap.Frames.MiniSquareBackground, "SecureHandlerBaseTemplate")
MaxiMap.Frames.ParentFrame[10]:SetFrameStrata("HIGH")
MaxiMap.Frames.ParentFrame[10]:SetAllPoints(GarrisonLandingPageMinimapButton)
GarrisonLandingPageMinimapButton:SetParent(MaxiMap.Frames.ParentFrame[10])
MaxiMap.Frames.EnableContainer = CreateFrame("Frame")
MaxiMap.Frames.EnableFrame = {}
local Index
for i = 1, 20 do
Index = i
if (i > 10) then Index = Index - 10; end
MaxiMap.Frames.EnableFrame[i] = CreateFrame("Cooldown", nil, MaxiMap.Frames.EnableContainer,  "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
MaxiMap.Frames.EnableFrame[i]:SetID(Index)
MaxiMap.Frames.EnableFrame[i]:SetFrameRef("MaxiParent"..Index, MaxiMap.Frames.ParentFrame[Index])
if (i <= 10) then
MaxiMap.Frames.EnableFrame[i]:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("MaxiParent"..self:GetID())
Ref:Show()
]=])
MaxiMap.Frames.ParentFrame[i]:SetShown(MaxiMapPerDB.OptionValues[i])
else
MaxiMap.Frames.EnableFrame[i]:SetAttribute("_onshow", [=[
self:Hide()
local Ref = self:GetFrameRef("MaxiParent"..self:GetID())
Ref:Hide()
]=])
end
end
MaxiMap.Frames.Reposition = CreateFrame("Cooldown", nil, MaxiMap.Frames.EnableContainer,  "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
MaxiMap.Frames.MultiFrame = CreateFrame("Cooldown", nil, MaxiMap.Frames.EnableContainer,  "CooldownFrameTemplate, SecureHandlerShowHideTemplate")
if (IsAddOnLoaded("!KalielsTracker")) then
C_Timer.After(0, function()
local Offset = -12
if (MultiBarLeft:IsShown()) then Offset = Offset - VERTICAL_MULTI_BAR_WIDTH; end
if (MultiBarRight:IsShown()) then Offset = Offset - VERTICAL_MULTI_BAR_WIDTH; end
if (MultiBarLeft:IsShown() and MultiBarRight:IsShown()) then Offset = Offset - VERTICAL_MULTI_BAR_HORIZONTAL_SPACING; end
_G["!KalielsTrackerFrame"]:ClearAllPoints()
_G["!KalielsTrackerFrame"]:SetPoint("TOPRIGHT", MinimapCluster, "BOTTOMRIGHT", Offset, 0)
end)
end
if (IsAddOnLoaded("MoveAnything")) then
C_Timer.After(0, function()
MaxiMap.Data.MoveAnything = {296, 297, 300, 301, 302}
MaxiMap.Frames.MoveAnything = CreateFrame("Frame")
if (MAOptions:IsShown()) then MaxiMap.Frames.MoveAnything:SetScript("OnUpdate", MaxiMap.Functions.MoveAnything); end
MAOptions:HookScript("OnShow", function() MaxiMap.Frames.MoveAnything:SetScript("OnUpdate", MaxiMap.Functions.MoveAnything) end)
Minimap:SetScript("OnMouseWheel", nil)
GameTimeFrame.MAPoint = nil
GameTimeFrame.MAHidden = true
GameTimeFrame:ClearAllPoints()
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GameTimeFrame[1]) then GameTimeFrame:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GameTimeFrame[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GameTimeFrame[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GameTimeFrame[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].GameTimeFrame[5]); else GameTimeFrame:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "TOPLEFT", -5, -14); end
MiniMapMailFrame.MAPoint = nil
MiniMapMailFrame.MAHidden = true
MiniMapMailFrame:ClearAllPoints()
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapMailFrame[1]) then MiniMapMailFrame:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapMailFrame[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapMailFrame[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapMailFrame[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapMailFrame[5]); else MiniMapMailFrame:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "TOPRIGHT", 0, -40); end
QueueStatusMinimapButton.MAPoint = nil
QueueStatusMinimapButton.MAHidden = true
QueueStatusMinimapButton:ClearAllPoints()
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].QueueStatusMinimapButton[1]) then QueueStatusMinimapButton:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].QueueStatusMinimapButton[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].QueueStatusMinimapButton[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].QueueStatusMinimapButton[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].QueueStatusMinimapButton[5]); else QueueStatusMinimapButton:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "TOPRIGHT", 0, -75); end
MiniMapTracking.MAPoint = nil
MiniMapTracking.MAHidden = true
MiniMapTracking:ClearAllPoints()
if (MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapTracking[1]) then MiniMapTracking:SetPoint(MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapTracking[1], MaxiMap.Frames.MiniSquareBackground, MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapTracking[3], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapTracking[4], MaxiMapPerDB.MapPositions[MaxiMapPerDB.MapZoom].MiniMapTracking[5]); else MiniMapTracking:SetPoint("CENTER", MaxiMap.Frames.MiniSquareBackground, "TOPRIGHT", 0, -110); end
TimeManagerClockButton.MAPoint = nil
TimeManagerClockButton.MAHidden = true
TimeManagerClockButton:ClearAllPoints()
TimeManagerClockButton:SetPoint("CENTER", MaxiMap.Frames.ParentFrame[2], "CENTER", -2, -1)
end)
end
end
function MaxiMap.Functions.CreateEvents()
MaxiMap.Frames.MiniSquareBackground:SetAttribute("_onmousewheel", [=[
if (IsAltKeyDown()) then
local Scale = delta * 10
local Ref = self:GetFrameRef("Minimap")
local Size = Ref:GetHeight() + Scale
if (Size >= 139 and Size <= 881) then
Ref:SetWidth(Size)
Ref:SetHeight(Size)
self:SetAttribute("minimapsize", Size)
local Ref2 = Ref:GetParent()
Ref2:SetWidth(Size + 52)
Ref2:SetHeight(Size + 52)
self:SetWidth(Size + 10)
self:SetHeight(Size + 10)
Ref2 = self:GetFrameRef("ZoomButton")
Ref2:SetAttribute("mapzoom", 2)
local Pos1, Pos2, xPos, yPos
Ref2 = self:GetFrameRef("ZoomButton")
Ref = self:GetFrameRef("GameTimeFrame")
Pos1, _, Pos2, xPos, yPos = Ref:GetPoint()
if (Pos1 == "CENTER" and Pos2 == "CENTER") then
if (xPos < 0) then xPos = xPos -  (delta * 6); else xPos = xPos +  (delta * 6); end
if (yPos < 0) then yPos = yPos -  (delta * 6); else yPos = yPos +  (delta * 6); end
Ref:ClearAllPoints()
Ref:SetPoint("CENTER", self, "CENTER", xPos, yPos)
Ref2:SetAttribute("GameTimeFrameX2", xPos)
Ref2:SetAttribute("GameTimeFrameY2", yPos)
end
Ref = self:GetFrameRef("GarrisonLandingPageMinimapButton")
Pos1, _, Pos2, xPos, yPos = Ref:GetPoint()
if (Pos1 == "CENTER" and Pos2 == "CENTER") then
if (xPos < 0) then xPos = xPos -  (delta * 6); else xPos = xPos +  (delta * 6); end
if (yPos < 0) then yPos = yPos -  (delta * 6); else yPos = yPos +  (delta * 6); end
Ref:ClearAllPoints()
Ref:SetPoint("CENTER", self, "CENTER", xPos, yPos)
Ref2:SetAttribute("GarrisonLandingPageMinimapButtonX2", xPos)
Ref2:SetAttribute("GarrisonLandingPageMinimapButtonY2", yPos)
end
local Offset = 5
Ref = self:GetFrameRef("ZoomButton")
Pos1, _, Pos2, xPos, yPos = Ref:GetPoint()
if (Pos1 == "CENTER" and Pos2 == "CENTER") then
if (xPos < 0) then xPos = xPos -  (delta * Offset); else xPos = xPos +  (delta * Offset); end
if (yPos < 0) then yPos = yPos -  (delta * Offset); else yPos = yPos +  (delta * Offset); end
Ref:ClearAllPoints()
Ref:SetPoint("CENTER", self, "CENTER", xPos, yPos)
Ref2:SetAttribute("MaxiMapZoomX2", xPos)
Ref2:SetAttribute("MaxiMapZoomY2", yPos)
end
Ref = self:GetFrameRef("MiniMapMailFrame")
Pos1, _, Pos2, xPos, yPos = Ref:GetPoint()
if (Pos1 == "CENTER" and Pos2 == "CENTER") then
if (xPos < 0) then xPos = xPos -  (delta * Offset); else xPos = xPos +  (delta * Offset); end
if (yPos < 0) then yPos = yPos -  (delta * Offset); else yPos = yPos +  (delta * Offset); end
Ref:ClearAllPoints()
Ref:SetPoint("CENTER", self, "CENTER", xPos, yPos)
Ref2:SetAttribute("MiniMapMailFrameX2", xPos)
Ref2:SetAttribute("MiniMapMailFrameY2", yPos)
end
Ref = self:GetFrameRef("QueueStatusMinimapButton")
Pos1, _, Pos2, xPos, yPos = Ref:GetPoint()
if (Pos1 == "CENTER" and Pos2 == "CENTER") then
if (xPos < 0) then xPos = xPos -  (delta * Offset); else xPos = xPos +  (delta * Offset); end
if (yPos < 0) then yPos = yPos -  (delta * Offset); else yPos = yPos +  (delta * Offset); end
Ref:ClearAllPoints()
Ref:SetPoint("CENTER", self, "CENTER", xPos, yPos)
Ref2:SetAttribute("QueueStatusMinimapButtonX2", xPos)
Ref2:SetAttribute("QueueStatusMinimapButtonY2", yPos)
end
Ref = self:GetFrameRef("MiniMapTracking")
Pos1, _, Pos2, xPos, yPos = Ref:GetPoint()
if (Pos1 == "CENTER" and Pos2 == "CENTER") then
if (xPos < 0) then xPos = xPos -  (delta * Offset); else xPos = xPos +  (delta * Offset); end
if (yPos < 0) then yPos = yPos -  (delta * Offset); else yPos = yPos +  (delta * Offset); end
Ref:ClearAllPoints()
Ref:SetPoint("CENTER", self, "CENTER", xPos, yPos)
Ref2:SetAttribute("MiniMapTrackingX2", xPos)
Ref2:SetAttribute("MiniMapTrackingY2", yPos)
end
Ref = self:GetFrameRef("ContainerButton")
Pos1, _, Pos2, xPos, yPos = Ref:GetPoint()
if (Pos1 == "CENTER" and Pos2 == "CENTER") then
if (xPos < 0) then xPos = xPos -  (delta * Offset); else xPos = xPos +  (delta * Offset); end
if (yPos < 0) then yPos = yPos -  (delta * Offset); else yPos = yPos +  (delta * Offset); end
Ref:ClearAllPoints()
Ref:SetPoint("CENTER", self, "CENTER", xPos, yPos)
Ref2:SetAttribute("MaxiMapButtonX2", xPos)
Ref2:SetAttribute("MaxiMapButtonY2", yPos)
end
Ref = self:GetFrameRef("ContainerButton")
local Pos1, _, Pos2, _, _ = Ref:GetPoint()
if (Pos1 == "BOTTOMRIGHT" and Pos2 == "BOTTOMRIGHT") then
Ref = self:GetFrameRef("VerticalBars")
local _, RightBottom, _, RightHeight = Ref:GetRect()
local BarWidth = 0
if (RightBottom and RightHeight) then
Ref = self:GetFrameRef("ButtonContainer")
local RightTop = RightBottom + RightHeight
local _, BarBottom, _, BarHeight = Ref:GetRect()
local BarTop = BarBottom + BarHeight
if ((BarBottom <= RightTop) and (BarTop >= RightBottom)) then
Ref, Ref2 = self:GetFrameRef("MultiBarLeft"), self:GetFrameRef("MultiBarRight")
if (Ref:IsShown()) then BarWidth = BarWidth + Ref:GetWidth(); end
if (Ref2:IsShown()) then BarWidth = BarWidth + Ref2:GetWidth(); end
if (Ref:IsShown() and Ref2:IsShown()) then BarWidth = BarWidth + 2; end
end
end
Ref = self:GetFrameRef("ContainerButton")
Ref:ClearAllPoints()
Ref:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", 25 - BarWidth, -19)
end
self:SetAttribute("scaled", true)
self:SetAttribute("minimapunset", false)
else
self:SetAttribute("scaled", nil)
end
end
]=])
MaxiMap.Frames.MiniSquareBackground:HookScript('OnMouseWheel', function(Self, Delta)
if (IsAltKeyDown()) then
if (Self:GetAttribute("scaled")) then
local Size = Self:GetAttribute("minimapsize")
MinimapBackdrop:SetWidth(Size + 52)
MinimapBackdrop:SetHeight(Size + 52)
local ZoomCurrent = Minimap:GetZoom()
local ZoomLevel = ZoomCurrent + 1
if (ZoomLevel >= Minimap:GetZoomLevels()) then ZoomLevel = 0; end
MaxiMapPerDB.MapSize = Size
MaxiMapPerDB.MapUnset = Self:GetAttribute("minimapunset")
Minimap:SetZoom(ZoomLevel)
Minimap:SetZoom(ZoomCurrent)
MaxiMapPerDB.MapZoom = 2
MaxiMap.Frames.ZoomButton:SetNormalTexture("Interface\\MINIMAP\\UI-Minimap-ZoomInButton-Up")
MaxiMap.Frames.ZoomButton:SetPushedTexture("Interface\\MINIMAP\\UI-Minimap-ZoomInButton-Down")
MaxiMap.Functions.SavePosition()
end
else
local Scale, MaxScale = Minimap:GetZoom() + Delta, Minimap:GetZoomLevels()
Minimap:SetZoom(Scale >= MaxScale and MaxScale or Scale <= 0 and 0 or Scale)
end
end)
MaxiMap.Frames.ZoomButton:SetAttribute("_onclick", [=[
local Ref = self:GetFrameRef("MiniSquareBackground")
local MapZoom = self:GetAttribute("mapzoom")
if (MapZoom == 3) then MapZoom = 1; else MapZoom = MapZoom + 1; end
self:SetAttribute("mapzoom", MapZoom)
local Size
if (MapZoom == 1) then Size = 140; elseif (MapZoom == 2) then 	if (Ref:GetAttribute("minimapunset")) then Size = 270; else Size = Ref:GetAttribute("minimapsize"); end; 	else Size = 880; end
Ref:SetWidth(Size + 10)
Ref:SetHeight(Size + 10)
Ref = self:GetFrameRef("Minimap")
Ref:SetWidth(Size)
Ref:SetHeight(Size)
local Ref2 = Ref:GetParent()
Ref2:SetWidth(Size + 52)
Ref2:SetHeight(Size + 52)
Ref = self:GetFrameRef("MiniSquareBackground")
Ref2 = self:GetFrameRef("GameTimeFrame")
Ref2:ClearAllPoints()
if (self:GetAttribute("GameTimeFrameX"..MapZoom)) then Ref2:SetPoint("CENTER", Ref, "CENTER", self:GetAttribute("GameTimeFrameX"..MapZoom), self:GetAttribute("GameTimeFrameY"..MapZoom)); else Ref2:SetPoint("CENTER", Ref, "TOPLEFT", -5, -14); end
Ref2 = self:GetFrameRef("GarrisonLandingPageMinimapButton")
Ref2:ClearAllPoints()
if (self:GetAttribute("GarrisonLandingPageMinimapButtonX"..MapZoom)) then Ref2:SetPoint("CENTER", Ref, "CENTER", self:GetAttribute("GarrisonLandingPageMinimapButtonX"..MapZoom), self:GetAttribute("GarrisonLandingPageMinimapButtonY"..MapZoom)); else Ref2:SetPoint("CENTER", Ref, "TOPLEFT", -5, -74); end
self:ClearAllPoints()
if (self:GetAttribute("MaxiMapZoomX"..MapZoom)) then self:SetPoint("CENTER", Ref, "CENTER", self:GetAttribute("MaxiMapZoomX"..MapZoom), self:GetAttribute("MaxiMapZoomY"..MapZoom)); else self:SetPoint("CENTER", Ref, "TOPRIGHT", 0, -5); end
Ref2 = self:GetFrameRef("MiniMapMailFrame")
Ref2:ClearAllPoints()
if (self:GetAttribute("MiniMapMailFrameX"..MapZoom)) then Ref2:SetPoint("CENTER", Ref, "CENTER", self:GetAttribute("MiniMapMailFrameX"..MapZoom), self:GetAttribute("MiniMapMailFrameY"..MapZoom)); else Ref2:SetPoint("CENTER", Ref, "TOPRIGHT", 0, -40); end
Ref2 = self:GetFrameRef("QueueStatusMinimapButton")
Ref2:ClearAllPoints()
if (self:GetAttribute("QueueStatusMinimapButtonX"..MapZoom)) then Ref2:SetPoint("CENTER", Ref, "CENTER", self:GetAttribute("QueueStatusMinimapButtonX"..MapZoom), self:GetAttribute("QueueStatusMinimapButtonY"..MapZoom)); else Ref2:SetPoint("CENTER", Ref, "TOPRIGHT", 0, -75); end
Ref2 = self:GetFrameRef("MiniMapTracking")
Ref2:ClearAllPoints()
if (self:GetAttribute("MiniMapTrackingX"..MapZoom)) then Ref2:SetPoint("CENTER", Ref, "CENTER", self:GetAttribute("MiniMapTrackingX"..MapZoom), self:GetAttribute("MiniMapTrackingY"..MapZoom)); else Ref2:SetPoint("CENTER", Ref, "TOPRIGHT", 0, -110); end
Ref2 = self:GetFrameRef("ContainerButton")
Ref2:ClearAllPoints()
if (self:GetAttribute("MaxiMapButtonX"..MapZoom)) then Ref2:SetPoint("CENTER", Ref, "CENTER", self:GetAttribute("MaxiMapButtonX"..MapZoom), self:GetAttribute("MaxiMapButtonY"..MapZoom)); else Ref2:SetPoint("BOTTOMRIGHT", Ref, "BOTTOMRIGHT", 25, -19); end
Ref = self:GetFrameRef("ContainerButton")
local Pos1, _, Pos2, _, _ = Ref:GetPoint()
if (Pos1 == "BOTTOMRIGHT" and Pos2 == "BOTTOMRIGHT") then
Ref = self:GetFrameRef("VerticalBars")
local _, RightBottom, _, RightHeight = Ref:GetRect()
local BarWidth = 0
if (RightBottom and RightHeight) then
Ref = self:GetFrameRef("ButtonContainer")
local RightTop = RightBottom + RightHeight
local _, BarBottom, _, BarHeight = Ref:GetRect()
local BarTop = BarBottom + BarHeight
if ((BarBottom <= RightTop) and (BarTop >= RightBottom)) then
Ref, Ref2 = self:GetFrameRef("MultiBarLeft"), self:GetFrameRef("MultiBarRight")
if (Ref:IsShown()) then BarWidth = BarWidth + Ref:GetWidth(); end
if (Ref2:IsShown()) then BarWidth = BarWidth + Ref2:GetWidth(); end
if (Ref:IsShown() and Ref2:IsShown()) then BarWidth = BarWidth + 2; end
end
end
Ref = self:GetFrameRef("MiniSquareBackground")
Ref2 = self:GetFrameRef("ContainerButton")
Ref2:ClearAllPoints()
Ref2:SetPoint("BOTTOMRIGHT", Ref, "BOTTOMRIGHT", 25 - BarWidth, -19)
end
]=])
MaxiMap.Frames.ZoomButton:HookScript("OnClick", function(Self)
local MapZoom = Self:GetAttribute("mapzoom")
local Size
if (MapZoom == 1) then Size = 140; elseif (MapZoom == 2) then if (MaxiMap.Frames.MiniSquareBackground:GetAttribute("minimapunset")) then Size = 270; else Size = MaxiMap.Frames.MiniSquareBackground:GetAttribute("minimapsize"); end; else Size = 880; end
MinimapBackdrop:SetWidth(Size + 52)
MinimapBackdrop:SetHeight(Size + 52)
local ZoomCurrent = Minimap:GetZoom()
local ZoomLevel = ZoomCurrent + 1
if (ZoomLevel >= Minimap:GetZoomLevels()) then ZoomLevel = 0; end
MaxiMapPerDB.MapZoom = MapZoom
if (MaxiMapPerDB.MapZoom == 3) then
MaxiMap.Frames.ZoomButton:SetNormalTexture("Interface\\MINIMAP\\UI-Minimap-ZoomOutButton-Up")
MaxiMap.Frames.ZoomButton:SetPushedTexture("Interface\\MINIMAP\\UI-Minimap-ZoomOutButton-Down")
else
MaxiMap.Frames.ZoomButton:SetNormalTexture("Interface\\MINIMAP\\UI-Minimap-ZoomInButton-Up")
MaxiMap.Frames.ZoomButton:SetPushedTexture("Interface\\MINIMAP\\UI-Minimap-ZoomInButton-Down")
end
Minimap:SetZoom(ZoomLevel)
Minimap:SetZoom(ZoomCurrent)
if (Self:IsMouseOver()) then
GameTooltip:Hide()
MaxiMap.Functions.Tooltip(Self)
end
end)
MaxiMap.Frames.ZoomButton:SetScript("OnEnter", function(Self, Motion)
if (not Motion) then return; end
MaxiMap.Functions.Tooltip(Self)
end)
MaxiMap.Frames.ZoomButton:SetScript("OnLeave", function(Self, Motion)
if (not Motion) then return; end
GameTooltip:Hide()
end)
MaxiMap.Frames.ContainerButton:SetAttribute("_onclick", [=[
local Ref = self:GetFrameRef("ButtonContainer")
if (Ref:IsShown()) then Ref:Hide(); else Ref:Show(); end
]=])
MaxiMap.Frames.ContainerButton:HookScript("OnClick", function()
MaxiMapPerDB.ButtonsShown = not MaxiMapPerDB.ButtonsShown
MaxiMap.Data.ReShow = nil
end)
MaxiMap.Frames.ContainerButton:SetScript("OnEnter", function(Self, Motion)
if (not Motion) then return; end
MaxiMap.Functions.Tooltip(Self, "Show/Hide Additional Minimap Buttons")
end)
MaxiMap.Frames.ContainerButton:SetScript("OnLeave", function(Self, Motion)
if (not Motion) then return; end
GameTooltip:Hide()
end)
MaxiMap.Frames.MultiFrame:SetAttribute("_onshow", [=[
self:Hide()
local Ref, Ref2, Ref3, Ref4 = self:GetFrameRef("MultiBars"), self:GetFrameRef("MultiBarLeft"), self:GetFrameRef("MultiBarRight"), self:GetFrameRef("UIParent")
Ref:ClearAllPoints()
Ref:SetHeight(self:GetAttribute("VERTICAL_MULTI_BAR_HEIGHT"))
Ref2:SetScale(1)
Ref3:SetScale(1)
Ref:SetPoint("RIGHT", Ref4, "RIGHT", 0, self:GetAttribute("multioffset"))
]=])
MaxiMap.Frames.Reposition:SetAttribute("_onshow", [=[
self:Hide()
Ref = self:GetFrameRef("ContainerButton")
local Pos1, _, Pos2, _, _ = Ref:GetPoint()
if (Pos1 == "BOTTOMRIGHT" and Pos2 == "BOTTOMRIGHT") then
Ref = self:GetFrameRef("VerticalBars")
local _, RightBottom, _, RightHeight = Ref:GetRect()
local BarWidth = 0
if (RightBottom and RightHeight) then
Ref = self:GetFrameRef("ButtonContainer")
local RightTop = RightBottom + RightHeight
local _, BarBottom, _, BarHeight = Ref:GetRect()
local BarTop = BarBottom + BarHeight
if ((BarBottom <= RightTop) and (BarTop >= RightBottom)) then
Ref, Ref2 = self:GetFrameRef("MultiBarLeft"), self:GetFrameRef("MultiBarRight")
if (Ref:IsShown()) then BarWidth = BarWidth + Ref:GetWidth(); end
if (Ref2:IsShown()) then BarWidth = BarWidth + Ref2:GetWidth(); end
if (Ref:IsShown() and Ref2:IsShown()) then BarWidth = BarWidth + 2; end
end
end
Ref = self:GetFrameRef("MiniSquareBackground")
Ref2 = self:GetFrameRef("ContainerButton")
Ref2:ClearAllPoints()
Ref2:SetPoint("BOTTOMRIGHT", Ref, "BOTTOMRIGHT", 25 - BarWidth, -19)
end
]=])
MaxiMap.Frames.Reset.Yes:SetScript("OnClick", function()
MaxiMap.Frames.Event:UnregisterEvent("PLAYER_REGEN_DISABLED")
MaxiMap.Frames.Event:UnregisterEvent("PLAYER_REGEN_ENABLED")
MaxiMapPerDB = nil
ReloadUI()
end)
MaxiMap.Frames.Reset.No:SetScript("OnClick", function() MaxiMap.Frames.Reset:Hide() end)
end
function MaxiMap.Functions.CreateReferences()
MaxiMap.Frames.MiniSquareBackground:SetAttribute("minimapsize", MaxiMapPerDB.MapSize)
MaxiMap.Frames.MiniSquareBackground:SetAttribute("minimapunset", MaxiMapPerDB.MapUnset)
MaxiMap.Frames.ZoomButton:SetAttribute("mapzoom", MaxiMapPerDB.MapZoom)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("Minimap", Minimap)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("ZoomButton", MaxiMap.Frames.ZoomButton)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("MinimapBackdrop", MinimapBackdrop)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("VerticalBars", VerticalMultiBarsContainer)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("ButtonContainer", MaxiMap.Frames.ButtonContainer)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("ContainerButton", MaxiMap.Frames.ContainerButton)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("MultiBarLeft", MultiBarLeft)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("MultiBarRight", MultiBarRight)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("GameTimeFrame", GameTimeFrame)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("GarrisonLandingPageMinimapButton", GarrisonLandingPageMinimapButton)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("MiniMapMailFrame", MiniMapMailFrame)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("QueueStatusMinimapButton", QueueStatusMinimapButton)
MaxiMap.Frames.MiniSquareBackground:SetFrameRef("MiniMapTracking", MiniMapTracking)
MaxiMap.Frames.ZoomButton:SetFrameRef("Minimap", Minimap)
MaxiMap.Frames.ZoomButton:SetFrameRef("MiniSquareBackground", MaxiMap.Frames.MiniSquareBackground)
MaxiMap.Frames.ZoomButton:SetFrameRef("MinimapBackdrop", MinimapBackdrop)
MaxiMap.Frames.ZoomButton:SetFrameRef("VerticalBars", VerticalMultiBarsContainer)
MaxiMap.Frames.ZoomButton:SetFrameRef("ButtonContainer", MaxiMap.Frames.ButtonContainer)
MaxiMap.Frames.ZoomButton:SetFrameRef("ContainerButton", MaxiMap.Frames.ContainerButton)
MaxiMap.Frames.ZoomButton:SetFrameRef("MultiBarLeft", MultiBarLeft)
MaxiMap.Frames.ZoomButton:SetFrameRef("MultiBarRight", MultiBarRight)
MaxiMap.Frames.ZoomButton:SetFrameRef("GameTimeFrame", GameTimeFrame)
MaxiMap.Frames.ZoomButton:SetFrameRef("GarrisonLandingPageMinimapButton", GarrisonLandingPageMinimapButton)
MaxiMap.Frames.ZoomButton:SetFrameRef("MiniMapMailFrame", MiniMapMailFrame)
MaxiMap.Frames.ZoomButton:SetFrameRef("QueueStatusMinimapButton", QueueStatusMinimapButton)
MaxiMap.Frames.ZoomButton:SetFrameRef("MiniMapTracking", MiniMapTracking)
MaxiMap.Frames.ContainerButton:SetFrameRef("ButtonContainer", MaxiMap.Frames.ButtonContainer)
MaxiMap.Frames.Reposition:SetFrameRef("VerticalBars", VerticalMultiBarsContainer)
MaxiMap.Frames.Reposition:SetFrameRef("ButtonContainer", MaxiMap.Frames.ButtonContainer)
MaxiMap.Frames.Reposition:SetFrameRef("MultiBarLeft", MultiBarLeft)
MaxiMap.Frames.Reposition:SetFrameRef("MultiBarRight", MultiBarRight)
MaxiMap.Frames.Reposition:SetFrameRef("MiniSquareBackground", MaxiMap.Frames.MiniSquareBackground)
MaxiMap.Frames.Reposition:SetFrameRef("ContainerButton", MaxiMap.Frames.ContainerButton)
MaxiMap.Frames.MultiFrame:SetFrameRef("MultiBars", VerticalMultiBarsContainer)
MaxiMap.Frames.MultiFrame:SetFrameRef("MultiBarLeft", MultiBarLeft)
MaxiMap.Frames.MultiFrame:SetFrameRef("MultiBarRight", MultiBarRight)
MaxiMap.Frames.MultiFrame:SetFrameRef("UIParent", UIParent)
MaxiMap.Frames.MultiFrame:SetAttribute("VERTICAL_MULTI_BAR_HEIGHT", VERTICAL_MULTI_BAR_HEIGHT)
end
SLASH_MAXIMAP1, SLASH_MAXIMAP2, SLASH_MAXIMAP3, SLASH_MAXIMAP4 = "/MaxiMap", "/maximap", "/maxi", "/mm"
function SlashCmdList.MAXIMAP()
if InterfaceOptionsFrame:IsShown() then
InterfaceOptionsFrame:Hide()
else
InterfaceOptionsFrame_OpenToCategory(MaxiMapOptions)
InterfaceOptionsFrame_OpenToCategory(MaxiMapOptions)
end
end
MaxiMap.Frames.Options = CreateFrame("Frame", "MaxiMapOptions", InterfaceOptionsFramePanelContainer)
MaxiMap.Frames.Event = CreateFrame("Frame")
MaxiMap.Frames.Event:RegisterEvent("ADDON_LOADED")
MaxiMap.Frames.Event:RegisterEvent("PLAYER_ENTERING_WORLD")
function MaxiMap.Frames.Event:OnEvent(Event, Self, ...)
if (Event == "ADDON_LOADED" and Self == "MaxiMap") then
MaxiMap.Frames.Event:UnregisterEvent("ADDON_LOADED")
MaxiMap.Data = {}
MaxiMap.Data.Title, MaxiMap.Data.Version = GetAddOnMetadata(Self, "Title"), GetAddOnMetadata(Self, "Version")
if (UnitAffectingCombat("player")) then
print(" ")
print("|cffff7d0a"..MaxiMap.Data.Title, "v"..MaxiMap.Data.Version, "|cffffe00a".."You've logged in during combat, please wait a few moments...")
end
end
if (Event == "PLAYER_ENTERING_WORLD") then
MaxiMap.Frames.Event:UnregisterEvent("PLAYER_ENTERING_WORLD")
if (UnitAffectingCombat("player")) then
MaxiMap.Frames.Event:SetScript("OnUpdate", function()
if (not UnitAffectingCombat("player")) then
MaxiMap.Frames.Event:SetScript("OnUpdate", nil)
MaxiMap.Functions.InitData()
end
end)
else
MaxiMap.Functions.InitData()
end
end
if (Event == "PLAYER_REGEN_DISABLED") then
if (MaxiMapPerDB.OptionValues.CombatHide and MaxiMap.Frames.ButtonContainer:IsShown()) then
MaxiMap.Frames.ButtonContainer:Hide()
MaxiMapPerDB.ButtonsShown = false
MaxiMap.Data.ReShow = true
end
end
if (Event == "PLAYER_REGEN_ENABLED") then
if (MaxiMap.Data.ReShow) then
MaxiMap.Frames.ButtonContainer:Show()
MaxiMapPerDB.ButtonsShown = true
MaxiMap.Data.ReShow = nil
end
end
end
MaxiMap.Frames.Event:SetScript("OnEvent", MaxiMap.Frames.Event.OnEvent)